    001    /*
    002     * Copyright (C) 2011 The Guava Authors
    003     *
    004     * Licensed under the Apache License, Version 2.0 (the "License");
    005     * you may not use this file except in compliance with the License.
    006     * You may obtain a copy of the License at
    007     *
    008     * http://www.apache.org/licenses/LICENSE-2.0
    009     *
    010     * Unless required by applicable law or agreed to in writing, software
    011     * distributed under the License is distributed on an "AS IS" BASIS,
    012     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    013     * See the License for the specific language governing permissions and
    014     * limitations under the License.
    015     */
    016
    017    package com.google.common.cache;
    018
    019    import com.google.common.annotations.Beta;
    020    import com.google.common.annotations.GwtCompatible;
    021    import com.google.common.base.Function;
    022    import com.google.common.collect.ImmutableMap;
    023    import com.google.common.util.concurrent.ExecutionError;
    024    import com.google.common.util.concurrent.UncheckedExecutionException;
    025
    026    import java.util.concurrent.ConcurrentMap;
    027    import java.util.concurrent.ExecutionException;
    028
    029    /**
    030     * A semi-persistent mapping from keys to values. Values are automatically loaded by the cache,
    031     * and are stored in the cache until either evicted or manually invalidated.
    032     *
    033     * <p>Implementations of this interface are expected to be thread-safe, and can be safely accessed
    034     * by multiple concurrent threads.
    035     *
    036     * <p>When evaluated as a {@link Function}, a cache yields the same result as invoking
    037     * {@link #getUnchecked}.
    038     *
    039     * <p>Note that while this class is still annotated as {@link Beta}, the API is frozen from a
    040     * consumer's standpoint. In other words existing methods are all considered {@code non-Beta} and
    041     * won't be changed without going through an 18 month deprecation cycle; however new methods may be
    042     * added at any time.
    043     *
    044     * @author Charles Fry
    045     * @since 11.0
    046     */
    047    @Beta
    048    @GwtCompatible
    049    public interface LoadingCache<K, V> extends Cache<K, V>, Function<K, V> {
    050
    051      /**
    052       * Returns the value associated with {@code key} in this cache, first loading that value if
    053       * necessary. No observable state associated with this cache is modified until loading completes.
    054       *
    055       * <p>If another call to {@link #get} or {@link #getUnchecked} is currently loading the value for
    056       * {@code key}, simply waits for that thread to finish and returns its loaded value. Note that
    057       * multiple threads can concurrently load values for distinct keys.
    058       *
    059       * <p>Caches loaded by a {@link CacheLoader} will call {@link CacheLoader#load} to load new values
    060       * into the cache. Newly loaded values are added to the cache using
    061       * {@code Cache.asMap().putIfAbsent} after loading has completed; if another value was associated
    062       * with {@code key} while the new value was loading then a removal notification will be sent for
    063       * the new value.
    064       *
    065       * <p>If the cache loader associated with this cache is known not to throw checked
    066       * exceptions, then prefer {@link #getUnchecked} over this method.
    067       *
    068       * @throws ExecutionException if a checked exception was thrown while loading the value
    069       * @throws UncheckedExecutionException if an unchecked exception was thrown while loading the
    070       *     value
    071       * @throws ExecutionError if an error was thrown while loading the value
    072       */
    073      V get(K key) throws ExecutionException;
    074
    075      /**
    076       * Returns the value associated with {@code key} in this cache, first loading that value if
    077       * necessary. No observable state associated with this cache is modified until loading
    078       * completes. Unlike {@link #get}, this method does not throw a checked exception, and thus should
    079       * only be used in situations where checked exceptions are not thrown by the cache loader.
    080       *
    081       * <p>If another call to {@link #get} or {@link #getUnchecked} is currently loading the value for
    082       * {@code key}, simply waits for that thread to finish and returns its loaded value. Note that
    083       * multiple threads can concurrently load values for distinct keys.
    084       *
    085       * <p>Caches loaded by a {@link CacheLoader} will call {@link CacheLoader#load} to load new values
    086       * into the cache. Newly loaded values are added to the cache using
    087       * {@code Cache.asMap().putIfAbsent} after loading has completed; if another value was associated
    088       * with {@code key} while the new value was loading then a removal notification will be sent for
    089       * the new value.
    090       *
    091       * <p><b>Warning:</b> this method silently converts checked exceptions to unchecked exceptions,
    092       * and should not be used with cache loaders which throw checked exceptions. In such cases use
    093       * {@link #get} instead.
    094       *
    095       * @throws UncheckedExecutionException if an exception was thrown while loading the value,
    096       *     regardless of whether the exception was checked or unchecked
    097       * @throws ExecutionError if an error was thrown while loading the value
    098       */
    099      V getUnchecked(K key);
    100
    101      /**
    102       * Returns a map of the values associated with {@code keys}, creating or retrieving those values
    103       * if necessary. The returned map contains entries that were already cached, combined with newly
    104       * loaded entries; it will never contain null keys or values.
    105       *
    106       * <p>Caches loaded by a {@link CacheLoader} will issue a single request to
    107       * {@link CacheLoader#loadAll} for all keys which are not already present in the cache. All
    108       * entries returned by {@link CacheLoader#loadAll} will be stored in the cache, over-writing
    109       * any previously cached values. This method will throw an exception if
    110       * {@link CacheLoader#loadAll} returns {@code null}, returns a map containing null keys or values,
    111       * or fails to return an entry for each requested key.
    112       *
    113       * <p>Note that duplicate elements in {@code keys}, as determined by {@link Object#equals}, will
    114       * be ignored.
    115       *
    116       * @throws ExecutionException if a checked exception was thrown while loading the values
    117       * @throws UncheckedExecutionException if an unchecked exception was thrown while loading the
    118       *     values
    119       * @throws ExecutionError if an error was thrown while loading the values
    120       * @since 11.0
    121       */
    122      ImmutableMap<K, V> getAll(Iterable<? extends K> keys) throws ExecutionException;
    123
    124      /**
    125       * Discouraged. Provided to satisfy the {@code Function} interface; use {@link #get} or
    126       * {@link #getUnchecked} instead.
    127       *
    128       * @throws UncheckedExecutionException if an exception was thrown while loading the value,
    129       *     regardless of whether the exception was checked or unchecked
    130       * @throws ExecutionError if an error was thrown while loading the value
    131       */
    132      @Override
    133      V apply(K key);
    134
    135      /**
    136       * Loads a new value for key {@code key}, possibly asynchronously. While the new value is loading
    137       * the previous value (if any) will continue to be returned by {@code get(key)} unless it is
    138       * evicted. If the new value is loaded successfully it will replace the previous value in the
    139       * cache; if an exception is thrown while refreshing the previous value will remain, <i>and the
    140       * exception will be logged (using {@link java.util.logging.Logger}) and swallowed</i>.
    141       *
    142       * <p>Caches loaded by a {@link CacheLoader} will call {@link CacheLoader#reload} if the
    143       * cache currently contains a value for {@code key}, and {@link CacheLoader#load} otherwise.
    144       * Loading is asynchronous only if {@link CacheLoader#reload} was overridden with an
    145       * asynchronous implementation.
    146       *
    147       * <p>Returns without doing anything if another thread is currently loading the value for
    148       * {@code key}. If the cache loader associated with this cache performs refresh asynchronously
    149       * then this method may return before refresh completes.
    150       *
    151       * @since 11.0
    152       */
    153      void refresh(K key);
    154
    155      /**
    156       * {@inheritDoc}
    157       *
    158       * <p><b>Note that although the view <i>is</i> modifiable, no method on the returned map will ever
    159       * cause entries to be automatically loaded.</b>
    160       */
    161      @Override
    162      ConcurrentMap<K, V> asMap();
    163    }